# Refund a payment with auto-unapplying Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Refunds a full or partial unapplied payment to your customers, without the need to unapply the payment first, followed by processing the refund. To refund applied payments, you can now leverage this API to unapply and refund the payment simultaneously. For more information on the payment refund use case, see Payment schedules use cases in the Knowledge Center. For more information, see Refund a payment with auto-unapplying. Endpoint: POST /v1/payments/{paymentKey}/refunds/unapply Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Path parameters: - `paymentKey` (string, required) The unique ID or number of an unapplied payment. For example, 8a8082e65b27f6c3015b89e4344c16b1, or P-00000001. ## Request fields (application/json): - `comment` (string) Comments about the refund. - `debitMemos` (array) Container for debit memos. The maximum number of debit memos is 1,000. - `debitMemos.amount` (number, required) The amount that is applied from the payment to the debit memo. - `debitMemos.debitMemoId` (string) The unique ID of the debit memo that the payment is applied to. If debitMemoId or debitMemoNumber is specified, the writeOff value can be set to true. This enables writing off a debit memo at the time of refund. Note: - The Payment Cross Account (PCA) feature is in the Early Adopter phase. - When PCA is enabled for the tenant, you can specify a debit memo / invoice that is different from the account that is specified in the request body. - `debitMemos.debitMemoNumber` (string) The number of the debit memo that the payment is applied to. Note: - The Payment Cross Account (PCA) feature is in the Early Adopter phase. - When PCA is enabled for the tenant, you can specify a debit memo / invoice that is different from the account that is specified in the request body. - `debitMemos.items` (array) Container for debit memo items. The maximum number of items is 1,000. Note: This field is only available if you have the [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) feature enabled. Invoice Item Settlement must be used together with other Invoice Settlement features (Unapplied Payments, and Credit and Debit memos). If you wish to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. - `debitMemos.items.amount` (number, required) The amount of the payment that is applied to the specific debit memo or taxation item. - `debitMemos.items.debitMemoItemId` (string) The ID of the specific debit memo item. - `debitMemos.items.taxItemId` (string) The ID of the specific taxation item. - `financeInformation` (object) Container for the finance information related to the refund. - `financeInformation.bankAccountAccountingCode` (string) The accounting code that maps to a bank account in your accounting system. - `financeInformation.transferredToAccounting` (string) Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite. Enum: "Processing", "Yes", "No", "Error", "Ignore" - `financeInformation.unappliedPaymentAccountingCode` (string) The accounting code for the unapplied payment. - `gatewayOptions` (object) The field used to pass gateway-specific parameters and parameter values. The fields supported by gateways vary. For more information, see the Overview topic of each gateway integration in [Zuora Knowledge Center](https://knowledgecenter.zuora.com/Zuora_Billing/Billing_and_Payments/M_Payment_Gateways/Supported_Payment_Gateways). Zuora sends all the information that you specified to the gateway. If you specify any unsupported gateway option parameters, they will be ignored without error prompts. - `gatewayOptions.key` (string) The name of a gateway-specific parameter. - `gatewayOptions.value` (string) The value of the gateway-specific parameter. - `invoices` (array) Container for invoices. The maximum number of invoices is 1,000. - `invoices.amount` (number, required) The amount that is applied from the payment to the invoice. - `invoices.invoiceId` (string) The unique ID of the invoice that the payment is applied to. If invoiceId or invoiceNumber is specified, the writeOff value can be set to true. This enables writing off a debit memo at the time of refund. Note: - The Payment Cross Account (PCA) feature is in the Early Adopter phase. - When PCA is enabled for the tenant, you can specify a debit memo / invoice that is different from the account that is specified in the request body. - `invoices.invoiceNumber` (string) The number of the invoice that the payment is applied to. For example, INV00000001. Note: When both the invoiceNumber and invoiceId fields are specified, the two fields must match with each other. - The Payment Cross Account (PCA) feature is in the Early Adopter phase. - When PCA is enabled for the tenant, you can specify a debit memo / invoice that is different from the account that is specified in the request body. - `invoices.items` (array) Container for invoice items. The maximum number of items is 1,000. Note: This field is only available if you have the [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) feature enabled. Invoice Item Settlement must be used together with other Invoice Settlement features (Unapplied Payments, and Credit and Debit memos). If you wish to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. - `invoices.items.amount` (number, required) The amount of the payment that is applied to the specific invoice or taxation item. - `invoices.items.invoiceItemId` (string) The ID of the specific invoice item. - `methodType` (string) How an external refund was issued to a customer. This field is required for an external refund and must be left empty for an electronic refund. You can issue an external refund on an electronic payment. Enum: "ACH", "Cash", "Check", "CreditCard", "PayPal", "WireTransfer", "DebitCard", "CreditCardReferenceTransaction", "BankTransfer", "Other" - `reasonCode` (string) A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code. - `referenceId` (string) The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments. - `refundDate` (string) The date when the refund takes effect, in yyyy-mm-dd format. The date of the refund cannot be before the payment date. Specify this field only for external refunds. Zuora automatically generates this field for electronic refunds. - `secondRefundReferenceId` (string) The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments. - `softDescriptor` (string) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `softDescriptorPhone` (string) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `totalAmount` (number) The total amount of the refund. If you do not specify a value, Zuora initiates a full refund of the payment amount, which is the sum of the applied and unapplied payment amounts. - Full Refund: If the refund amount and debit memo/ invoice are not specified, then the payment will be unapplied completely, followed by processing a full refund. - Partial Refund: - If the total amount is specified, and the debit memo/invoice is not specified, you can unapply the refund amount from the available debit memo/invoice and refund the unapplied payment to the customer. - If the total amount is specified, along with the debit memo and the invoice, you can unapply the applied payments from the mentioned invoices and debit memos, and refund the unapplied payments to customers. Example: 10 - `type` (string, required) The type of the refund. Enum: "External", "Electronic" - `refundTransactionType` (string) The transaction type of the refund. Enum: "Chargeback", "PaymentReversal" - `writeOff` (boolean) Indicates whether to write off a document. - `writeOffOptions` (object) Container for the write-off information to create credit memo. - `writeOffOptions.comment` (string) Comments about the credit memo which is created as a result of the write off. - `writeOffOptions.memoDate` (string) The date when the credit memo takes effect. - `writeOffOptions.reasonCode` (string) A code identifying the reason for the credit memo. - `writeOffOptions.taxAutoCalculation` (boolean) Specifies whether taxes are automatically recalculated for the credit memo generated during the write-off process. When set to true, the system fetches the latest tax rates from the tax vendor instead of copying the tax amounts from the original invoice. The default value is false. Note: This feature is in the Early Availability phase. Contact Zuora Global Support to enable this feature before using it. - `IntegrationId__NS` (string) ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `IntegrationStatus__NS` (string) Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `Origin__NS` (string) Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SyncDate__NS` (string) Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SynctoNetSuite__NS` (string) Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ## Response 200 fields (application/json): - `accountId` (string) The ID of the account associated with this refund. Zuora associates the refund automatically with the account from the associated payment. - `amount` (number) The total amount of the refund. - `cancelledOn` (string) The date and time when the refund was cancelled, in yyyy-mm-dd hh:mm:ss format. - `comment` (string) Comments about the refund. - `createdById` (string) The ID of the Zuora user who created the refund. - `createdDate` (string) The date and time when the refund was created, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-01 15:31:10. - `creditMemoId` (string) The ID of the credit memo associated with the refund. - `financeInformation` (object) Container for the finance information related to the refund. - `financeInformation.bankAccountAccountingCode` (string) The accounting code that maps to a bank account in your accounting system. - `financeInformation.bankAccountAccountingCodeType` (string) The type of the accounting code that maps to a bank account in your accounting system. - `financeInformation.transferredToAccounting` (string) Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite. Enum: "Processing", "Yes", "No", "Error", "Ignore" - `financeInformation.unappliedPaymentAccountingCode` (string) The accounting code for the unapplied payment. - `financeInformation.unappliedPaymentAccountingCodeType` (string) The type of the accounting code for the unapplied payment. - `gatewayId` (string) The ID of the gateway instance that processes the refund. - `gatewayReconciliationReason` (string) The reason of gateway reconciliation. - `gatewayReconciliationStatus` (string) The status of gateway reconciliation. - `gatewayResponse` (string) The message returned from the payment gateway for the refund. This message is gateway-dependent. - `gatewayResponseCode` (string) The code returned from the payment gateway for the refund. This code is gateway-dependent. - `gatewayState` (string) The status of the refund in the gateway. Enum: "MarkedForSubmission", "Submitted", "Settled", "NotSubmitted", "FailedToSettle" - `id` (string) The ID of the created refund. - `markedForSubmissionOn` (string) The date and time when a refund was marked and waiting for batch submission to the payment process, in yyyy-mm-dd hh:mm:ss format. - `methodType` (string) How an external refund was issued to a customer. Enum: "ACH", "Cash", "Check", "CreditCard", "PayPal", "WireTransfer", "DebitCard", "CreditCardReferenceTransaction", "BankTransfer", "Other" - `number` (string) The unique identification number of the refund. - `paymentGatewayNumber` (string) The natural key for the payment gateway. - `paymentId` (string) The ID of the payment that is refunded. - `paymentMethodId` (string) The unique ID of the payment method that the customer used to make the refund. - `paymentMethodSnapshotId` (string) The unique ID of the payment method snapshot, which is a copy of the particular payment method used in a transaction. - `payoutId` (string) The payout ID of the refund from the gateway side. - `reasonCode` (string) A code identifying the reason for the transaction. - `referenceId` (string) The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments. - `refundDate` (string) The date when the refund takes effect, in yyyy-mm-dd format. - `refundTransactionTime` (string) The date and time when the refund was issued, in yyyy-mm-dd hh:mm:ss format. - `secondRefundReferenceId` (string) The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments. - `settledOn` (string) The date and time when the refund was settled in the payment processor, in yyyy-mm-dd hh:mm:ss format. This field is used by the Spectrum gateway only and not applicable to other gateways. - `softDescriptor` (string) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `softDescriptorPhone` (string) A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi. - `status` (string) The status of the refund. Enum: "Processed", "Canceled", "Error", "Processing" - `submittedOn` (string) The date and time when the refund was submitted, in yyyy-mm-dd hh:mm:ss format. - `success` (boolean) Returns true if the request was processed successfully. - `type` (string) The type of the refund. Enum: "External", "Electronic" - `updatedById` (string) The ID of the the Zuora user who last updated the refund. - `updatedDate` (string) The date and time when the refund was last updated, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-02 15:36:10. - `writeOffResults` (object) Container for the write-off information of credit memo and apply information. - `writeOffResults.errorMessage` (string) The error message about write off failed. - `writeOffResults.transactions` (object) The credit memo apply information. - `writeOffResults.transactions.appliedAmount` (number) The credit memo applied amopunt. - `writeOffResults.transactions.creditMemoAmount` (string) The credit memo amount. - `writeOffResults.transactions.creditMemoNumber` (string) The unique identification number of the credit memo. - `writeOffResults.transactions.creditMemoStatus` (string) The status of the credit memo. Enum: "Draft", "Posted", "Canceled", "Error", "PendingForTax", "Generating", "CancelInProgress" - `writeOffResults.transactions.invoiceNumber` (string) The unique identification number of the invoice. - `IntegrationId__NS` (string) ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `IntegrationStatus__NS` (string) Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `Origin__NS` (string) Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SyncDate__NS` (string) Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SynctoNetSuite__NS` (string) Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.